package spiral.all;

/**
 * <p>Title: Spiral analyzis</p>
 * <p>Description: Tda pro uchovn informace o configuraci generovn</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 */

public class Configuration {
  private double fi, dfi, p;
  private int a, b, A, B, ds;

  /**
   * Vytvo novou konfiguraci pro generovn spirly
   * @param fi poet otek (hel)
   * @param a koeficient x
   * @param b koeficient y
   * @param ds rozte mezi body
   * @param am1 1. amplituda
   * @param am2 2. amplituda
   * @param p pomr fi a 2. umu
   * @param dfi prustek hlu 1. umu
   */
  public Configuration(double fi, int a, int b, int ds, int am1, int am2, double p, double dfi) {
    this.fi = fi;
    this.a = a;
    this.b = b;
    this.ds = ds;
    this.A = am1;
    this.B = am2;
    this.p = p;
    this.dfi = dfi;
  }

  /**
   * Vrac hel fi (poet otek spirly), se kterm byla/m bt spirla generovna
   * @return hel
   */
  public double getFI() {
    return fi;
  }

  /**
   * Vrac parametr a (koeficient x), se kterm byla/m bt spirla generovna
   * @return a
   */
  public int getA() {
    return a;
  }

  /**
   * Vrac parametr b (koeficient y), se kterm byla/m bt spirla generovna
   * @return b
   */
  public int getB() {
    return b;
  }

  /**
       * Vrac parametr ds (rozte mezi body), se kterm byla/m bt spirla generovna
   * @return ds
   */
  public int getDS() {
    return ds;
  }

  /**
       * Vrac parametr A (amlituda 1. umu), se kterm byla/m bt spirla generovna
   * @return A
   */
  public int getAM1() {
    return A;
  }

  /**
       * Vrac parametr B (amlituda 2. umu), se kterm byla/m bt spirla generovna
   * @return B
   */
  public int getAM2() {
    return B;
  }

  /**
   * Vrac parametr p (pomr mezi hlem generovn 2. umu a aktulnm hlem spirly), se kterm byla/m bt spirla generovna
   * @return p
   */
  public double getPOMER() {
    return p;
  }

  /**
   * Vrac parametr dfi (prustek hlu 1. umu), se kterm byla/m bt spirla generovna
   * @return dfi
   */
  public double getDFI() {
    return dfi;
  }
}