package spiral.all;

/**
 * <p>Title: Spiral analyzis</p>
 * <p>Description: Rozhran, kter mus implementovat kad tda, kter chce zobrazovat a poskytovat data aplikaci</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Dolezel
 * @version 1.0
 */

public interface GUI {
  /**
   * Vype etzec uivateli
   * @param str etzec
   */
  public void mShow(String str);

  /**
   * Pekresl oblast, kde se m kreslit spirla
   */
  public void grafRepaint();

  /**
   * Nakresl ru z bodu 1 do bodu 2.
   * @param x1 x-ov souadnice 1. bodu
   * @param y1 y-ov souadnice 1. bodu
   * @param x2 x-ov souadnice 2. bodu
   * @param y2 y-ov souadnice 2. bodu
   */
  public void mDraw(int x1, int y1, int x2, int y2);

  /**
   * Vrac maximln ku Graphics, na kterou se vykresluje spirla
   * @return rka Graphics
   */
  public int getMaxX();

  /**
   * Vrac maximln vku Graphics, na kterou se vykresluje spirla
   * @return vka Graphics
   */
  public int getMaxY();

  /**
   * Vrac rozlien, pro kter se m spotat DOS
   * @return rozlien
   */
  public int getDPI();

  /**
   * Vrac frekvenci, se kterou se maj brt body pro vpoet DOS
   * @return frekvence (!= 0)
   */
  public int getHZ();
}