package spiral.test;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import spiral.all.*;

/**
 * <p>Title: Spiral analyzis</p>
 * <p>Description: Program pro testovn spirl</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Dolezel
 * @version 1.0
 */

public class Frame
    extends JFrame
    implements GUI {
  private Engine engine;
  private int can = 0;
  private int x = 0, y = 0;
  private long begin = 0;

  class MyJPanel extends JPanel {
    public void paint(Graphics g) {
      super.paint(g);
      int w = getWidth() - 2;
      int h = getHeight() - 1;
      g.setColor(Color.WHITE);
      g.fillRect(0, 0, w, h);
      g.setColor(Color.BLACK);
      g.drawLine(0, 0, 0, h);
      g.drawLine(0, h, w, h);
      g.drawLine(w, h, w, 0);
      g.drawLine(w, 0, 0, 0);
      engine.repaint(g);
    }
  }

  private JPanel contentPane;
  private JToolBar jToolBar = new JToolBar();
  private JButton OpenFile = new JButton();
  private JButton CloseFile = new JButton();
  private JButton Help = new JButton();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel2 = new JPanel();
  private JFileChooser Chooser = new JFileChooser();
  JPanel jPanel3 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel Graf;
  JTextArea TextArea = new JTextArea();
  JScrollPane jScrollPane1 = new JScrollPane(TextArea);
  JButton SaveFile = new JButton();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  JButton compute = new JButton();
  BorderLayout borderLayout3 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JTextField dpi = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField a = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField b = new JTextField();
  JLabel jLabel4 = new JLabel();
  JTextField ds = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField fi = new JTextField();
  JPanel jPanel6 = new JPanel();
  JLabel jLabel6 = new JLabel();
  JTextField ampl1 = new JTextField();
  JLabel jLabel7 = new JLabel();
  JTextField dfi = new JTextField();
  JLabel jLabel8 = new JLabel();
  JTextField ampl2 = new JTextField();
  JLabel jLabel9 = new JLabel();
  JTextField pomer = new JTextField();
  JButton text = new JButton();
  JLabel jLabel10 = new JLabel();
  JTextField hz = new JTextField();
  JButton SaveData = new JButton();

  public void mShow(String str) {
    TextArea.append("\n" + str);
  }

  public void mDraw(int x1, int y1, int x2, int y2) {
    Graf.getGraphics().drawLine(x1, y1, x2, y2);
  }

  public int getMaxX() {
    return Graf.getWidth();
  }

  public int getMaxY() {
    return Graf.getHeight();
  }

  public int getHZ() {
    int res = Integer.parseInt(hz.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  public int getDPI() {
    int res = Integer.parseInt(dpi.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private double getFI() {
    double res = Double.parseDouble(fi.getText());
    if (res < 0) {
      return 0;
    }
    return res * 2 * Math.PI;
  }

  private int getA() {
    int res = Integer.parseInt(a.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private int getB() {
    int res = Integer.parseInt(b.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private int getDS() {
    int res = Integer.parseInt(ds.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private int getAM1() {
    int res = Integer.parseInt(ampl1.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private int getAM2() {
    int res = Integer.parseInt(ampl2.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private double getPOMER() {
    double res = Double.parseDouble(pomer.getText());
    if (res < 0) {
      return 0;
    }
    return res;
  }

  private double getDFI() {
    double res = Double.parseDouble(dfi.getText());
    if (res < 0) {
      return 0;
    }
    return Math.PI / res;
  }

  /*  public void paint(Graphics g) {
      super.paint(g);
      engine.repaint();
    }*/

  //Construct the frame
  public Frame() {
    this.engine = new Engine(this);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    Graf = new MyJPanel();
    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(1000, 800));
    this.setTitle("Spiral analyzis - test");
    this.addWindowListener(new Frame_this_windowAdapter(this));
    OpenFile.addActionListener(new Frame_OpenFile_actionAdapter(this));
    OpenFile.setToolTipText("Open File");
    OpenFile.setIcon(null);
    OpenFile.setText("Load Spiral");
    CloseFile.addActionListener(new Frame_CloseFile_actionAdapter(this));
    CloseFile.setToolTipText("Generate");
    CloseFile.setIcon(null);
    CloseFile.setText("Generuj");
    Help.addActionListener(new Frame_Help_actionAdapter(this));
    Help.setToolTipText("Draw Spiral");
    Help.setIcon(null);
    Help.setText("Kresli");
    jPanel1.setLayout(borderLayout2);
    jPanel3.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setRows(1);
    TextArea.setFont(new java.awt.Font("SansSerif", 0, 12));
    TextArea.setForeground(Color.black);
    TextArea.setText("Vysledky:");
    Graf.addMouseMotionListener(new Frame_Graf_mouseMotionAdapter(this));
    SaveFile.setText("Save Spiral");
    SaveFile.addActionListener(new Frame_SaveFile_actionAdapter(this));
    jPanel2.setLayout(borderLayout3);
    compute.setText("Spocitej");
    compute.addActionListener(new Frame_compute_actionAdapter(this));
    jLabel1.setText("dpi:  ");
    dpi.setText("1000");
    dpi.setColumns(5);
    jLabel2.setText("a:  ");
    a.setSelectionStart(4);
    a.setText("200");
    a.setColumns(5);
    jLabel3.setText("  b:  ");
    b.setText("200");
    b.setColumns(5);
    jLabel4.setText("  ds:  ");
    ds.setText("300");
    ds.setColumns(5);
    jLabel5.setText("  otacek:  ");
    fi.setText("4");
    fi.setColumns(5);
    jLabel6.setText("ampl1:  ");
    ampl1.setText("0");
    ampl1.setColumns(5);
    jLabel7.setText("  dfi:  ");
    dfi.setText("3");
    dfi.setColumns(5);
    jLabel8.setText("  ampl2:  ");
    ampl2.setText("0");
    ampl2.setColumns(5);
    jLabel9.setText("  pomer:  ");
    pomer.setText("40");
    pomer.setColumns(5);
    text.setText("Smaz text");
    text.addActionListener(new Frame_text_actionAdapter(this));
    jLabel10.setText("  Hz:  ");
    hz.setText("200");
    hz.setColumns(5);
    SaveData.setText("Save Data");
    SaveData.addActionListener(new Frame_SaveData_actionAdapter(this));
    jPanel5.add(jLabel2, null);
    jPanel5.add(a, null);
    jToolBar.add(OpenFile);
    jToolBar.add(CloseFile);
    jToolBar.add(Help);
    jToolBar.add(SaveFile, null);
    jToolBar.add(SaveData, null);
    contentPane.add(jToolBar, BorderLayout.NORTH);
    contentPane.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jPanel5, BorderLayout.NORTH);
    jPanel2.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(jLabel1, null);
    jPanel4.add(dpi, null);
    jPanel4.add(jLabel10, null);
    jPanel4.add(hz, null);
    jPanel4.add(compute, null);
    jPanel1.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(Graf, null);
    jPanel3.add(jScrollPane1, null);
    jPanel5.add(jLabel3, null);
    jPanel5.add(b, null);
    jPanel5.add(jLabel4, null);
    jPanel5.add(ds, null);
    jPanel5.add(jLabel5, null);
    jPanel5.add(fi, null);
    jPanel2.add(jPanel6, BorderLayout.CENTER);
    jPanel6.add(jLabel6, null);
    jPanel6.add(ampl1, null);
    jPanel6.add(jLabel7, null);
    jPanel6.add(dfi, null);
    jPanel6.add(jLabel8, null);
    jPanel6.add(ampl2, null);
    jPanel6.add(jLabel9, null);
    jPanel6.add(pomer, null);
    jPanel4.add(text, null);
  }

  void OpenFile_actionPerformed(ActionEvent e) {
    if (JFileChooser.APPROVE_OPTION == Chooser.showOpenDialog(this)) {
      // Call openFile to attempt to load the text from file into TextArea
      engine.loadFile(Chooser.getSelectedFile().getPath());
    }
    this.repaint();
  }

  void CloseFile_actionPerformed(ActionEvent e) {
    if (can == 1) {
      return;
    }
    engine.generuj(new Configuration(getFI(), getA(), getB(), getDS(), getAM1(), getAM2(), getPOMER(), getDFI()));
    dpi.setText("1000");
  }

  void Help_actionPerformed(ActionEvent e) {
    can = 1 - can;
    if (can == 1) {
      engine.newData(null);
      begin = System.currentTimeMillis();
      Help.setText("Konec kresleni");
      dpi.setText("72");
    }
    else {
      x = y = 0;
      Help.setText("Kresli");
    }
    Graf.repaint();
  }

  void Graf_mouseDragged(MouseEvent e) {
    if (can == 1) {
      int time = (int) (System.currentTimeMillis() - begin);
      engine.newRow(e.getX(), e.getY(), time, 0);
      if ( (x == 0) && (y == 0)) {
        x = e.getX();
        y = e.getY();
      }
      Graf.getGraphics().drawLine(x, y, e.getX(), e.getY());
      x = e.getX();
      y = e.getY();
    }
  }

  void SaveFile_actionPerformed(ActionEvent e) {
    if (JFileChooser.APPROVE_OPTION == Chooser.showSaveDialog(this)) {
      engine.saveSpiral(Chooser.getSelectedFile().getPath());
    }
  }

  void compute_actionPerformed(ActionEvent e) {
    engine.compute();
  }

  void smaz_actionPerformed(ActionEvent e) {
    Graf.repaint();
  }

  void text_actionPerformed(ActionEvent e) {
    TextArea.setText("");
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(1);
  }

  void SaveData_actionPerformed(ActionEvent e) {
    engine.saveData();
  }

  public void grafRepaint() {
    Graf.repaint();
  }
}

class Frame_OpenFile_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_OpenFile_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.OpenFile_actionPerformed(e);
  }
}

class Frame_CloseFile_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_CloseFile_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.CloseFile_actionPerformed(e);
  }
}

class Frame_Graf_mouseMotionAdapter
    extends java.awt.event.MouseMotionAdapter {
  Frame adaptee;

  Frame_Graf_mouseMotionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseDragged(MouseEvent e) {
    adaptee.Graf_mouseDragged(e);
  }
}

class Frame_Help_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_Help_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.Help_actionPerformed(e);
  }
}

class Frame_SaveFile_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_SaveFile_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.SaveFile_actionPerformed(e);
  }
}

class Frame_text_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_text_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.text_actionPerformed(e);
  }
}

class Frame_compute_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_compute_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.compute_actionPerformed(e);
  }
}

class Frame_this_windowAdapter
    extends java.awt.event.WindowAdapter {
  Frame adaptee;

  Frame_this_windowAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}

class Frame_SaveData_actionAdapter
    implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_SaveData_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.SaveData_actionPerformed(e);
  }
}
